/*
*  Wolf - simple controller for Webot contest
*
* \author md@robotika.cz
*
*  $Revision: 1.11 $
*  $Date: 2002/10/30 19:38:55 $
*
*/

import com.cyberbotics.webots.Controller;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;

import java.io.*;


public abstract class ALife0 extends Controller //MyController
{
  static int ds0, ds1, ds2, ds3, ds4, ds5, ds6, ds7;

  static int camera;

  public static void reset()
  {
    camera=robot_get_device("camera");

    ds0 = robot_get_device("ds0");
    ds1 = robot_get_device("ds1");
    ds2 = robot_get_device("ds2");
    ds3 = robot_get_device("ds3");
    ds4 = robot_get_device("ds4");
    ds5 = robot_get_device("ds5");
    ds6 = robot_get_device("ds6");
    ds7 = robot_get_device("ds7");
  }



  public static void main(String[] args)
  {
    main();
  }



  public static void main()
  {
    SensorsStatus sensorsStatus = new SensorsStatus();
    Speed speed = new Speed(0, 0);

    double energyPrintLimit = 91.0;
    int globalTime = 0;

    int[] image;
    int width,height;
    int leftIR, rightIR;

    camera_enable(camera,64);
    distance_sensor_enable(ds0,64);
    distance_sensor_enable(ds1,64);
    distance_sensor_enable(ds2,64);
    distance_sensor_enable(ds3,64);
    distance_sensor_enable(ds4,64);
    distance_sensor_enable(ds5,64);
    distance_sensor_enable(ds6,64);
    distance_sensor_enable(ds7,64);

    robot_battery_sensor_enable(64);
    differential_wheels_enable_encoders(64);

    sensorsStatus.setImageParams(camera_get_width(camera), camera_get_height(camera) );

    int numSkills = 4;
    int currentSkillIndex = 1;
    Skill [] skill = new Skill[numSkills];

    skill[0] = new FollowWall(); //RndWalk(); // exception handler
    skill[1] = new LocateFeeder();
    skill[2] = new TrackFeeder();
    skill[3] = new TouchFeeder();

    skill[currentSkillIndex].init();
    for(;;)
    {
      sensorsStatus.setImage(camera_get_image(camera));

      sensorsStatus.setIR( 0, distance_sensor_get_value(ds0));
      sensorsStatus.setIR( 1, distance_sensor_get_value(ds1));
      sensorsStatus.setIR( 2, distance_sensor_get_value(ds2));
      sensorsStatus.setIR( 3, distance_sensor_get_value(ds3));
      sensorsStatus.setIR( 4, distance_sensor_get_value(ds4));
      sensorsStatus.setIR( 5, distance_sensor_get_value(ds5));
      sensorsStatus.setIR( 6, distance_sensor_get_value(ds6));
      sensorsStatus.setIR( 7, distance_sensor_get_value(ds7));

      sensorsStatus.setEnergy(robot_battery_sensor_get_value());
      sensorsStatus.setEncoders( differential_wheels_get_left_encoder(), differential_wheels_get_right_encoder() );


      differential_wheels_set_encoders(0, 0);
      differential_wheels_set_speed(speed.leftSpeed(), speed.rightSpeed());

      sensorsStatus.setLastSpeed(speed);

      try
      {
        speed = skill[currentSkillIndex].run(sensorsStatus);
        if(skill[currentSkillIndex].term())
        {
          currentSkillIndex = (currentSkillIndex + 1) % numSkills;
          skill[currentSkillIndex].init();

          Verbose.out("skill ("+ currentSkillIndex + ") " + skill[currentSkillIndex].name());
        }

        if(sensorsStatus.increasingEnergy() && (currentSkillIndex != 3))
        {
          currentSkillIndex = 3;
          Verbose.out("skill2 ("+ currentSkillIndex + ") " + skill[currentSkillIndex].name());
        }
      }
      catch (Exception e)
      {
        Verbose.out("exception thrown for skill "+ currentSkillIndex);
        speed.set(0, 0);
        currentSkillIndex = 0;
        skill[currentSkillIndex].init();
        Verbose.out("skill3 ("+ currentSkillIndex + ") " + skill[currentSkillIndex].name());
      }


      if(sensorsStatus.energy() > energyPrintLimit + 10)
      {
        Verbose.out("Charged energy to [" + globalTime + "]= " + sensorsStatus.energy());
        energyPrintLimit += 5;
      }

      if(sensorsStatus.energy() < energyPrintLimit)
      {
        Verbose.out("Robot's energy [" + globalTime + "]= " + sensorsStatus.energy());
        energyPrintLimit -= 10;
      }

      globalTime++;
      robot_step(64);
    }
  }
}
