/*
*  FollowWall - follow the wall (keep it on the right side)
*
* \author md@robotika.cz
*
*  $Revision: 1.1 $
*  $Date: 2002/10/30 19:38:55 $
*
*/

public class FollowWall extends LocateFeeder
{
  public String name() { return "FollowWall"; }

  public Speed run(SensorsStatus i_sensorsStatus) throws CannotHandleSituationException
  {
    if(i_sensorsStatus.stuck())
    {
      m_stuck++;
      if(m_stuck < 10)
        return m_lastSpeed;
      if(m_stuck < 20)
        return new Speed(-5, -5);
      if(m_stuck < 30)
        return new Speed(0, -5);
      if(m_stuck < 40)
        return new Speed(-5, 0);
      return new Speed(5, 5);
    }

    m_stuck = 0;
    m_lastSpeed = subRun(i_sensorsStatus);
    return m_lastSpeed;
  }

  public Speed subRun(SensorsStatus i_sensorsStatus) throws CannotHandleSituationException
  {
    evalTermCondition(i_sensorsStatus);

    int i;
    for(i = 0; i < 6; i++)
    {
      if(i_sensorsStatus.wall(i))
      {
        break;
      }
    }

    if(i <= 3)
    {
      m_mustTurn = 4;
    }

    if((i <= 4) || (m_mustTurn > 0))
    {
      m_mustTurn--;
      return new Speed(-5, 5);
    }

    if(i == 5)
    {
      return new Speed(10, 10);
    }

    return new Speed(10, 0);
  }

  int m_mustTurn = 0;

  Speed m_lastSpeed = new Speed(-5, -5);
  int m_stuck = 0;
}
