class Pose
{
  public void update(int i_encLeft, int i_encRight)
  {
    double angle = (- i_encLeft + i_encRight) * (2 * 3.1415 / 14660.0);
    double dist = 0.1 * (i_encLeft + i_encRight)/2.0;

    m_x += dist * Math.cos(m_heading);
    m_y += dist * Math.sin(m_heading);
    m_heading += angle;
  }

  public void update(Speed i_speed)
  {
    double angle = (- i_speed.leftSpeed() + i_speed.rightSpeed()) * (2 * 3.1415 / 660.0);
    double dist = (i_speed.leftSpeed() + i_speed.rightSpeed())/2.0;

    m_x += dist * Math.cos(m_heading);
    m_y += dist * Math.sin(m_heading);
    m_heading += angle;
  }

  public void print()
  {
    // output in "guido" standard IAngle = 100th of angle
    Verbose.out("O: " + Math.round(m_x) + " " + Math.round(m_y)+ " " + Math.round(m_heading * 18000 / 3.1415));
  }

  double m_x = 0, m_y = 0, m_heading = 0;
}