/*
*  SensorsStatus - information about the world from sensors
*
* \author md@robotika.cz
*
*  $Revision: 1.3 $
*  $Date: 2002/10/30 19:38:55 $
*
*/

public class SensorsStatus
{
  public void setImageParams(int i_width, int i_height)
  {
    m_width = i_width;
    m_height = i_height;
  }

  public void setIR(int i_index, int i_value)
  {
    m_IR[i_index] = i_value;
  }

  public int leftIR() { return m_IR[1]; }
  public int rightIR() { return m_IR[4]; }

  public int IR(int i_index) { return m_IR[i_index]; }
  public boolean wall(int i_index) { return (m_IR[i_index] > 200); }


  public void setImage(int [] i_image)
  {
    m_image = new Image(m_width, m_height, i_image);
  }

  public Image image() { return m_image; }


  public double energy() { return m_energy; }
  public void setEnergy(double i_energy) { m_prevEnergy = m_energy; m_energy = i_energy;}
  public boolean increasingEnergy() { return (m_energy > m_prevEnergy) && (m_prevEnergy > 0); }



  public void setEncoders(int i_encLeft, int i_encRight)
  {
    m_encLeft = i_encLeft;
    m_encRight = i_encRight;
    m_pose.update( i_encLeft, i_encRight );
  }

  boolean moving() { return (m_encLeft != 0) || (m_encRight != 0); }
  boolean stuck() { return !moving() && ((m_speed.leftSpeed() != 0) || (m_speed.rightSpeed() ==0)); }
  Pose pose() { return m_pose; }



  public void setLastSpeed(Speed i_speed)
  {
    m_speed = i_speed;
  }


// variables
  int m_height, m_width;
  int m_IR[] = new int[8];

  Image m_image;

  double m_energy, m_prevEnergy = 110.0; // just to be sure that it is more than 100

  int m_encLeft, m_encRight;

  Speed m_speed = new Speed(0,0);
  Pose m_pose = new Pose();
}
