/*
*  TrackFeeder - once you see the feeder, go to get it
*
* \author md@robotika.cz
*
*  $Revision: 1.4 $
*  $Date: 2002/10/30 19:38:55 $
*
*/

public class TrackFeeder extends Skill
{
  public String name() { return "TrackFeeder"; }

  public void init()
  {
    super.init();
    m_diff = 0;
  }

  public Speed run(SensorsStatus i_sensorsStatus) throws CannotHandleSituationException
  {
    Speed speed = new Speed(0, 0);
    int leftIR = i_sensorsStatus.leftIR();
    int rightIR = i_sensorsStatus.rightIR();

    Feeder feeder = new Feeder(i_sensorsStatus.image());

    if((leftIR > 100) && (feeder.size() < 10))
    {
      speed.set(10, -10);
    }
    else if ((rightIR > 100) && (feeder.size() < 10))
    {
      speed.set(-10, 10);
    }
    else
    {
      if(feeder.position() < 0)
      {
        // try to re-allocate position of the feeder
        if(m_diff < 0)
        {
          speed.set(10, 7);
        }
        else
        {
          speed.set(7, 10);
        }
        m_numMissingFeeder++;
      }
      else
      {
        m_numMissingFeeder = 0;

        if(feeder.position() + feeder.size()/2 < 80/2)
        {
          speed.set(9, 10);
        }
        else
        {
          speed.set(10, 9);
        }
      }
    }

    m_diff += speed.leftSpeed() - speed.rightSpeed();

    if(i_sensorsStatus.stuck() || (m_numMissingFeeder > 200))
    {
      m_numMissingFeeder = 0;
      throw new CannotHandleSituationException();
    }

    m_terminate = (feeder.size() > 30);
    return speed;
  }

  int m_diff = 0;
  int m_numMissingFeeder = 0;
}
